stash: take advantage of eval_gettextln
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
d27b876b 8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
9db31bdf 11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
1d5bec8b 14 or: $dashless [--quiet] sync [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
d0ad8251 17. git-sh-i18n
98fcf840 18. git-parse-remote
70c7ac22
LH
19require_work_tree
20
5c08dbbd 21command=
ecda0723 22branch=
d27b876b 23force=
d92a3959 24reference=
70c7ac22 25cached=
48bb3033
GP
26recursive=
27init=
1c244f6e 28files=
31ca3ac3 29nofetch=
32948425 30update=
15fc56a8 31prefix=
70c7ac22 32
f31a522a
ML
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
98fcf840 36 remote=$(get_default_remote)
8e7e6f39 37 remoteurl=$(git config "remote.$remote.url") ||
4d689320 38 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 39 url="$1"
99b120af 40 remoteurl=${remoteurl%/}
ea640cc6 41 sep=/
f31a522a
ML
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
ea640cc6
TR
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
497ee872 56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
ea640cc6
TR
57 ;;
58 esac
f31a522a
ML
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
ea640cc6 67 echo "$remoteurl$sep${url%/}"
f31a522a
ML
68}
69
a7b3269c
DA
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
313ee0d6
NMC
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
a7b3269c
DA
94}
95
941987a5
LH
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
537601ac 103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
fe22e542 104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
941987a5 107 test -z "$name" &&
497ee872 108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
941987a5
LH
109 echo "$name"
110}
33aa6fff
LH
111
112#
113# Clone a submodule
114#
23a485e3 115# Prior to calling, cmd_update checks that a possibly existing
ecda0723 116# path is not a git repository.
23a485e3 117# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
118# since it is the location of a new submodule.
119#
33aa6fff
LH
120module_clone()
121{
122 path=$1
123 url=$2
d92a3959 124 reference="$3"
33aa6fff 125
d92a3959
MT
126 if test -n "$reference"
127 then
128 git-clone "$reference" -n "$url" "$path"
129 else
130 git-clone -n "$url" "$path"
131 fi ||
497ee872 132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
33aa6fff
LH
133}
134
ecda0723
SV
135#
136# Add a new submodule to the working tree, .gitmodules and the index
137#
ec05df35 138# $@ = repo path
ecda0723
SV
139#
140# optional branch is stored in global branch variable
141#
23a485e3 142cmd_add()
ecda0723 143{
5c08dbbd
JH
144 # parse $args after "submodule ... add".
145 while test $# -ne 0
146 do
147 case "$1" in
148 -b | --branch)
149 case "$2" in '') usage ;; esac
150 branch=$2
151 shift
152 ;;
d27b876b
JL
153 -f | --force)
154 force=$1
155 ;;
5c08dbbd 156 -q|--quiet)
2e6a30ef 157 GIT_QUIET=1
5c08dbbd 158 ;;
d92a3959
MT
159 --reference)
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
162 shift
163 ;;
164 --reference=*)
165 reference="$1"
166 shift
167 ;;
5c08dbbd
JH
168 --)
169 shift
170 break
171 ;;
172 -*)
173 usage
174 ;;
175 *)
176 break
177 ;;
178 esac
179 shift
180 done
181
ecda0723
SV
182 repo=$1
183 path=$2
184
1414e578
JL
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
188 fi
189
ec05df35 190 if test -z "$repo" -o -z "$path"; then
ecda0723
SV
191 usage
192 fi
193
ec05df35
ML
194 # assure repo is absolute or relative to parent
195 case "$repo" in
196 ./*|../*)
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
199 ;;
200 *:*|/*)
201 # absolute url
202 realrepo=$repo
203 ;;
204 *)
497ee872 205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
206 ;;
207 esac
208
db75ada5
MG
209 # normalize path:
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
212 sed -e '
213 s|//*|/|g
214 s|^\(\./\)*||
215 s|/\./|/|g
216 :start
217 s|\([^/]*\)/\.\./||
218 tstart
219 s|/*$||
220 ')
5be60078 221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
497ee872 222 die "$(eval_gettext "'\$path' already exists in the index")"
ecda0723 223
d27b876b
JL
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
225 then
3a4c3ed7
ÆAB
226 (
227 eval_gettext "The following path is ignored by one of your .gitignore files:
228\$path
229Use -f if you really want to add it." &&
230 echo
231 ) >&2
d27b876b
JL
232 exit 1
233 fi
234
d4264ca3
ML
235 # perhaps the path exists and is already a git repo, else clone it
236 if test -e "$path"
237 then
e9656473 238 if test -d "$path"/.git -o -f "$path"/.git
d4264ca3 239 then
dc2204fe 240 eval_gettext "Adding existing repo at '\$path' to the index"; echo
d4264ca3 241 else
497ee872 242 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
d4264ca3 243 fi
c2f93917 244
d4264ca3 245 else
d4264ca3 246
d92a3959 247 module_clone "$path" "$realrepo" "$reference" || exit
ea10b60c 248 (
74ae1419 249 clear_local_git_env
ea10b60c
BJ
250 cd "$path" &&
251 # ash fails to wordsplit ${branch:+-b "$branch"...}
252 case "$branch" in
253 '') git checkout -f -q ;;
502dc5b6 254 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 255 esac
497ee872 256 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
d4264ca3 257 fi
c56dce3b 258 git config submodule."$path".url "$realrepo"
d4264ca3 259
d27b876b 260 git add $force "$path" ||
497ee872 261 die "$(eval_gettext "Failed to add submodule '\$path'")"
ecda0723 262
a5099bb4
IY
263 git config -f .gitmodules submodule."$path".path "$path" &&
264 git config -f .gitmodules submodule."$path".url "$repo" &&
31991b02 265 git add --force .gitmodules ||
497ee872 266 die "$(eval_gettext "Failed to register submodule '\$path'")"
ecda0723
SV
267}
268
19a31f9c
ML
269#
270# Execute an arbitrary command sequence in each checked out
271# submodule
272#
273# $@ = command to execute
274#
275cmd_foreach()
276{
1d5bec8b
JH
277 # parse $args after "submodule ... foreach".
278 while test $# -ne 0
279 do
280 case "$1" in
281 -q|--quiet)
282 GIT_QUIET=1
283 ;;
15fc56a8
JH
284 --recursive)
285 recursive=1
286 ;;
1d5bec8b
JH
287 -*)
288 usage
289 ;;
290 *)
291 break
292 ;;
293 esac
294 shift
295 done
296
f030c96d
ÆAB
297 toplevel=$(pwd)
298
4dca1aa6
BC
299 # dup stdin so that it can be restored when running the external
300 # command in the subshell (and a recursive call to this function)
301 exec 3<&0
302
a7b3269c 303 module_list |
19a31f9c
ML
304 while read mode sha1 stage path
305 do
306 if test -e "$path"/.git
307 then
490b6d57 308 say "$(eval_gettext "Entering '\$prefix\$path'")"
1e7f2aad 309 name=$(module_name "$path")
15fc56a8
JH
310 (
311 prefix="$prefix$path/"
74ae1419 312 clear_local_git_env
15fc56a8
JH
313 cd "$path" &&
314 eval "$@" &&
315 if test -n "$recursive"
316 then
317 cmd_foreach "--recursive" "$@"
318 fi
4dca1aa6 319 ) <&3 3<&- ||
497ee872 320 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
19a31f9c
ML
321 fi
322 done
323}
324
70c7ac22 325#
211b7f19 326# Register submodules in .git/config
70c7ac22
LH
327#
328# $@ = requested paths (default to all)
329#
23a485e3 330cmd_init()
70c7ac22 331{
5c08dbbd
JH
332 # parse $args after "submodule ... init".
333 while test $# -ne 0
334 do
335 case "$1" in
336 -q|--quiet)
2e6a30ef 337 GIT_QUIET=1
5c08dbbd
JH
338 ;;
339 --)
340 shift
341 break
342 ;;
343 -*)
344 usage
345 ;;
346 *)
347 break
348 ;;
349 esac
350 shift
351 done
352
a7b3269c 353 module_list "$@" |
70c7ac22
LH
354 while read mode sha1 stage path
355 do
211b7f19 356 # Skip already registered paths
941987a5 357 name=$(module_name "$path") || exit
2cd9de3e
JL
358 if test -z "$(git config "submodule.$name.url")"
359 then
360 url=$(git config -f .gitmodules submodule."$name".url)
361 test -z "$url" &&
0591c0a5 362 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
2cd9de3e
JL
363
364 # Possibly a url relative to parent
365 case "$url" in
366 ./*|../*)
367 url=$(resolve_relative_url "$url") || exit
368 ;;
369 esac
370 git config submodule."$name".url "$url" ||
0591c0a5 371 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
2cd9de3e 372 fi
70c7ac22 373
2cd9de3e 374 # Copy "update" setting when it is not set yet
32948425
JH
375 upd="$(git config -f .gitmodules submodule."$name".update)"
376 test -z "$upd" ||
2cd9de3e 377 test -n "$(git config submodule."$name".update)" ||
32948425 378 git config submodule."$name".update "$upd" ||
497ee872 379 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
ca2cedba 380
497ee872 381 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
70c7ac22
LH
382 done
383}
384
385#
211b7f19 386# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
387#
388# $@ = requested paths (default to all)
389#
23a485e3 390cmd_update()
70c7ac22 391{
5c08dbbd 392 # parse $args after "submodule ... update".
98dbe63d 393 orig_flags=
5c08dbbd
JH
394 while test $# -ne 0
395 do
396 case "$1" in
397 -q|--quiet)
2e6a30ef 398 GIT_QUIET=1
5c08dbbd 399 ;;
be4d2c83 400 -i|--init)
d92a3959 401 init=1
be4d2c83 402 ;;
31ca3ac3 403 -N|--no-fetch)
31ca3ac3
FF
404 nofetch=1
405 ;;
9db31bdf
NMC
406 -f|--force)
407 force=$1
408 ;;
ca2cedba 409 -r|--rebase)
32948425 410 update="rebase"
ca2cedba 411 ;;
d92a3959
MT
412 --reference)
413 case "$2" in '') usage ;; esac
414 reference="--reference=$2"
98dbe63d
KB
415 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
416 shift
d92a3959
MT
417 ;;
418 --reference=*)
419 reference="$1"
d92a3959 420 ;;
42b49178 421 -m|--merge)
42b49178
JH
422 update="merge"
423 ;;
b13fd5c1 424 --recursive)
b13fd5c1
JH
425 recursive=1
426 ;;
5c08dbbd
JH
427 --)
428 shift
429 break
430 ;;
431 -*)
432 usage
433 ;;
434 *)
435 break
436 ;;
437 esac
98dbe63d
KB
438 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
439 shift
5c08dbbd
JH
440 done
441
d92a3959
MT
442 if test -n "$init"
443 then
444 cmd_init "--" "$@" || return
445 fi
446
1b4735d9 447 cloned_modules=
15ffb7cd
FG
448 module_list "$@" | {
449 err=
70c7ac22
LH
450 while read mode sha1 stage path
451 do
313ee0d6
NMC
452 if test "$stage" = U
453 then
454 echo >&2 "Skipping unmerged submodule $path"
455 continue
456 fi
941987a5 457 name=$(module_name "$path") || exit
5be60078 458 url=$(git config submodule."$name".url)
32948425 459 update_module=$(git config submodule."$name".update)
211b7f19 460 if test -z "$url"
70c7ac22
LH
461 then
462 # Only mention uninitialized submodules when its
463 # path have been specified
464 test "$#" != "0" &&
1c2ef66f
ÆAB
465 say "$(eval_gettext "Submodule path '\$path' not initialized
466Maybe you want to use 'update --init'?")"
211b7f19
LH
467 continue
468 fi
469
ba88a1fe 470 if ! test -d "$path"/.git -o -f "$path"/.git
211b7f19 471 then
d92a3959 472 module_clone "$path" "$url" "$reference"|| exit
1b4735d9 473 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
474 subsha1=
475 else
74ae1419 476 subsha1=$(clear_local_git_env; cd "$path" &&
5be60078 477 git rev-parse --verify HEAD) ||
497ee872 478 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
70c7ac22 479 fi
211b7f19 480
32948425 481 if ! test -z "$update"
ca2cedba 482 then
32948425 483 update_module=$update
ca2cedba
PH
484 fi
485
70c7ac22
LH
486 if test "$subsha1" != "$sha1"
487 then
9db31bdf
NMC
488 subforce=$force
489 # If we don't already have a -f flag and the submodule has never been checked out
490 if test -z "$subsha1" -a -z "$force"
b9b378a0 491 then
9db31bdf 492 subforce="-f"
b9b378a0 493 fi
31ca3ac3
FF
494
495 if test -z "$nofetch"
496 then
e5f522d6
JL
497 # Run fetch only if $sha1 isn't present or it
498 # is not reachable from a ref.
74ae1419 499 (clear_local_git_env; cd "$path" &&
f5799e05 500 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 501 test -z "$rev") || git-fetch)) ||
497ee872 502 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
31ca3ac3
FF
503 fi
504
1b4735d9
SO
505 # Is this something we just cloned?
506 case ";$cloned_modules;" in
507 *";$name;"*)
508 # then there is no local change to integrate
509 update_module= ;;
510 esac
511
877449c1 512 must_die_on_failure=
32948425
JH
513 case "$update_module" in
514 rebase)
515 command="git rebase"
ee653c89
ÆAB
516 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
517 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
877449c1 518 must_die_on_failure=yes
32948425 519 ;;
42b49178
JH
520 merge)
521 command="git merge"
ee653c89
ÆAB
522 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
523 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
877449c1 524 must_die_on_failure=yes
42b49178 525 ;;
32948425 526 *)
9db31bdf 527 command="git checkout $subforce -q"
ee653c89
ÆAB
528 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
529 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
32948425
JH
530 ;;
531 esac
70c7ac22 532
15ffb7cd
FG
533 if (clear_local_git_env; cd "$path" && $command "$sha1")
534 then
ff968f03 535 say "$say_msg"
877449c1
JH
536 elif test -n "$must_die_on_failure"
537 then
ff968f03 538 die_with_status 2 "$die_msg"
15ffb7cd 539 else
ff968f03 540 err="${err};$die_msg"
877449c1 541 continue
15ffb7cd 542 fi
70c7ac22 543 fi
b13fd5c1
JH
544
545 if test -n "$recursive"
546 then
15ffb7cd
FG
547 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
548 res=$?
549 if test $res -gt 0
550 then
ff968f03 551 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
15ffb7cd
FG
552 if test $res -eq 1
553 then
ff968f03 554 err="${err};$die_msg"
15ffb7cd
FG
555 continue
556 else
ff968f03 557 die_with_status $res "$die_msg"
15ffb7cd
FG
558 fi
559 fi
b13fd5c1 560 fi
70c7ac22 561 done
15ffb7cd
FG
562
563 if test -n "$err"
564 then
565 OIFS=$IFS
566 IFS=';'
567 for e in $err
568 do
569 if test -n "$e"
570 then
571 echo >&2 "$e"
572 fi
573 done
574 IFS=$OIFS
575 exit 1
576 fi
577 }
70c7ac22
LH
578}
579
bffe71f4
EM
580set_name_rev () {
581 revname=$( (
74ae1419 582 clear_local_git_env
bffe71f4 583 cd "$1" && {
5be60078
JH
584 git describe "$2" 2>/dev/null ||
585 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
586 git describe --contains "$2" 2>/dev/null ||
587 git describe --all --always "$2"
bffe71f4
EM
588 }
589 ) )
590 test -z "$revname" || revname=" ($revname)"
591}
28f9af5d
PY
592#
593# Show commit summary for submodules in index or working tree
594#
595# If '--cached' is given, show summary between index and given commit,
596# or between working tree and given commit
597#
598# $@ = [commit (default 'HEAD'),] requested paths (default all)
599#
600cmd_summary() {
f2dc06a3 601 summary_limit=-1
d0f64dd4 602 for_status=
1c244f6e 603 diff_cmd=diff-index
f2dc06a3 604
28f9af5d
PY
605 # parse $args after "submodule ... summary".
606 while test $# -ne 0
607 do
608 case "$1" in
609 --cached)
610 cached="$1"
611 ;;
1c244f6e
JL
612 --files)
613 files="$1"
614 ;;
d0f64dd4
PY
615 --for-status)
616 for_status="$1"
617 ;;
f2dc06a3
PY
618 -n|--summary-limit)
619 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
620 then
621 :
622 else
623 usage
624 fi
625 shift
626 ;;
28f9af5d
PY
627 --)
628 shift
629 break
630 ;;
631 -*)
632 usage
633 ;;
634 *)
635 break
636 ;;
637 esac
638 shift
639 done
bffe71f4 640
f2dc06a3
PY
641 test $summary_limit = 0 && return
642
3deea89c 643 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
644 then
645 head=$rev
caa9c3ca 646 test $# = 0 || shift
3deea89c
JH
647 elif test -z "$1" -o "$1" = "HEAD"
648 then
14e940d7
JH
649 # before the first commit: compare with an empty tree
650 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 651 test -z "$1" || shift
28f9af5d 652 else
3deea89c 653 head="HEAD"
28f9af5d
PY
654 fi
655
1c244f6e
JL
656 if [ -n "$files" ]
657 then
658 test -n "$cached" &&
b9b9c22f 659 die "$(gettext -- "--cached cannot be used with --files")"
1c244f6e
JL
660 diff_cmd=diff-files
661 head=
662 fi
663
28f9af5d
PY
664 cd_to_toplevel
665 # Get modified modules cared by user
18076502 666 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 667 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
668 while read mod_src mod_dst sha1_src sha1_dst status name
669 do
670 # Always show modules deleted or type-changed (blob<->module)
671 test $status = D -o $status = T && echo "$name" && continue
672 # Also show added or modified modules which are checked out
673 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
674 echo "$name"
675 done
676 )
1cb639e6 677
d0f64dd4
PY
678 test -z "$modules" && return
679
18076502 680 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 681 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
682 cut -c2- |
683 while read mod_src mod_dst sha1_src sha1_dst status name
684 do
685 if test -z "$cached" &&
686 test $sha1_dst = 0000000000000000000000000000000000000000
687 then
688 case "$mod_dst" in
689 160000)
690 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
691 ;;
692 100644 | 100755 | 120000)
693 sha1_dst=$(git hash-object $name)
694 ;;
695 000000)
696 ;; # removed
697 *)
698 # unexpected type
dc2204fe
ÆAB
699 (
700 eval_gettext "unexpected mode \$mod_dst" &&
701 echo
702 ) >&2
1cb639e6
PY
703 continue ;;
704 esac
705 fi
706 missing_src=
707 missing_dst=
708
709 test $mod_src = 160000 &&
30353a40 710 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
711 missing_src=t
712
713 test $mod_dst = 160000 &&
30353a40 714 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 715 missing_dst=t
bffe71f4 716
1cb639e6
PY
717 total_commits=
718 case "$missing_src,$missing_dst" in
719 t,)
f62f8212 720 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
1cb639e6
PY
721 ;;
722 ,t)
f62f8212 723 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
724 ;;
725 t,t)
f62f8212 726 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
727 ;;
728 *)
729 errmsg=
730 total_commits=$(
731 if test $mod_src = 160000 -a $mod_dst = 160000
732 then
733 range="$sha1_src...$sha1_dst"
734 elif test $mod_src = 160000
735 then
736 range=$sha1_src
737 else
738 range=$sha1_dst
739 fi
740 GIT_DIR="$name/.git" \
b0e621ad 741 git rev-list --first-parent $range -- | wc -l
1cb639e6 742 )
eed35595 743 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
744 ;;
745 esac
746
747 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
748 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
749 if test $status = T
750 then
b3e73449
ÆAB
751 blob="$(gettext "blob")"
752 submodule="$(gettext "submodule")"
1cb639e6
PY
753 if test $mod_dst = 160000
754 then
b3e73449 755 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 756 else
b3e73449 757 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
758 fi
759 else
760 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
761 fi
762 if test -n "$errmsg"
763 then
764 # Don't give error msg for modification whose dst is not submodule
765 # i.e. deleted or changed to blob
766 test $mod_dst = 160000 && echo "$errmsg"
767 else
768 if test $mod_src = 160000 -a $mod_dst = 160000
769 then
f2dc06a3
PY
770 limit=
771 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 772 GIT_DIR="$name/.git" \
f2dc06a3 773 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
774 --first-parent $sha1_src...$sha1_dst
775 elif test $mod_dst = 160000
776 then
777 GIT_DIR="$name/.git" \
778 git log --pretty='format: > %s' -1 $sha1_dst
779 else
780 GIT_DIR="$name/.git" \
781 git log --pretty='format: < %s' -1 $sha1_src
782 fi
783 echo
784 fi
785 echo
d0f64dd4
PY
786 done |
787 if test -n "$for_status"; then
f17a5d34 788 if [ -n "$files" ]; then
165119e9 789 gettext "# Submodules changed but not updated:"; echo
f17a5d34 790 else
165119e9 791 gettext "# Submodule changes to be committed:"; echo
f17a5d34 792 fi
d0f64dd4
PY
793 echo "#"
794 sed -e 's|^|# |' -e 's|^# $|#|'
795 else
796 cat
797 fi
28f9af5d 798}
70c7ac22 799#
941987a5 800# List all submodules, prefixed with:
70c7ac22
LH
801# - submodule not initialized
802# + different revision checked out
803#
804# If --cached was specified the revision in the index will be printed
805# instead of the currently checked out revision.
806#
807# $@ = requested paths (default to all)
808#
23a485e3 809cmd_status()
70c7ac22 810{
5c08dbbd 811 # parse $args after "submodule ... status".
98dbe63d 812 orig_flags=
5c08dbbd
JH
813 while test $# -ne 0
814 do
815 case "$1" in
816 -q|--quiet)
2e6a30ef 817 GIT_QUIET=1
5c08dbbd
JH
818 ;;
819 --cached)
820 cached=1
821 ;;
64b19ffe
JH
822 --recursive)
823 recursive=1
824 ;;
5c08dbbd
JH
825 --)
826 shift
827 break
828 ;;
829 -*)
830 usage
831 ;;
832 *)
833 break
834 ;;
835 esac
98dbe63d 836 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
5c08dbbd
JH
837 shift
838 done
839
a7b3269c 840 module_list "$@" |
70c7ac22
LH
841 while read mode sha1 stage path
842 do
941987a5 843 name=$(module_name "$path") || exit
5be60078 844 url=$(git config submodule."$name".url)
64b19ffe 845 displaypath="$prefix$path"
313ee0d6
NMC
846 if test "$stage" = U
847 then
848 say "U$sha1 $displaypath"
849 continue
850 fi
ba88a1fe 851 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
70c7ac22 852 then
64b19ffe 853 say "-$sha1 $displaypath"
70c7ac22
LH
854 continue;
855 fi
41c7c1bd 856 set_name_rev "$path" "$sha1"
18076502 857 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
70c7ac22 858 then
64b19ffe 859 say " $sha1 $displaypath$revname"
70c7ac22
LH
860 else
861 if test -z "$cached"
862 then
74ae1419 863 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
41c7c1bd 864 set_name_rev "$path" "$sha1"
70c7ac22 865 fi
64b19ffe
JH
866 say "+$sha1 $displaypath$revname"
867 fi
868
869 if test -n "$recursive"
870 then
871 (
872 prefix="$displaypath/"
74ae1419 873 clear_local_git_env
64b19ffe 874 cd "$path" &&
a7eff1a8 875 eval cmd_status "$orig_args"
64b19ffe 876 ) ||
497ee872 877 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
70c7ac22
LH
878 fi
879 done
880}
2327f61e
DA
881#
882# Sync remote urls for submodules
883# This makes the value for remote.$remote.url match the value
884# specified in .gitmodules.
885#
886cmd_sync()
887{
888 while test $# -ne 0
889 do
890 case "$1" in
891 -q|--quiet)
2e6a30ef 892 GIT_QUIET=1
2327f61e
DA
893 shift
894 ;;
895 --)
896 shift
897 break
898 ;;
899 -*)
900 usage
901 ;;
902 *)
903 break
904 ;;
905 esac
906 done
907 cd_to_toplevel
908 module_list "$@" |
909 while read mode sha1 stage path
910 do
911 name=$(module_name "$path")
912 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
913
914 # Possibly a url relative to parent
915 case "$url" in
916 ./*|../*)
917 url=$(resolve_relative_url "$url") || exit
918 ;;
919 esac
920
ccee6086 921 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 922 then
0591c0a5 923 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
ccee6086
JH
924 git config submodule."$name".url "$url"
925
926 if test -e "$path"/.git
927 then
928 (
929 clear_local_git_env
930 cd "$path"
931 remote=$(get_default_remote)
932 git config remote."$remote".url "$url"
933 )
934 fi
2327f61e
DA
935 fi
936 done
937}
70c7ac22 938
5c08dbbd
JH
939# This loop parses the command line arguments to find the
940# subcommand name to dispatch. Parsing of the subcommand specific
941# options are primarily done by the subcommand implementations.
942# Subcommand specific options such as --branch and --cached are
943# parsed here as well, for backward compatibility.
944
945while test $# != 0 && test -z "$command"
70c7ac22
LH
946do
947 case "$1" in
2327f61e 948 add | foreach | init | update | status | summary | sync)
5c08dbbd 949 command=$1
70c7ac22
LH
950 ;;
951 -q|--quiet)
2e6a30ef 952 GIT_QUIET=1
70c7ac22 953 ;;
ecda0723
SV
954 -b|--branch)
955 case "$2" in
956 '')
957 usage
958 ;;
959 esac
960 branch="$2"; shift
961 ;;
70c7ac22 962 --cached)
28f9af5d 963 cached="$1"
70c7ac22
LH
964 ;;
965 --)
966 break
967 ;;
968 -*)
969 usage
970 ;;
971 *)
972 break
973 ;;
974 esac
975 shift
976done
977
5c08dbbd
JH
978# No command word defaults to "status"
979test -n "$command" || command=status
980
981# "-b branch" is accepted only by "add"
982if test -n "$branch" && test "$command" != add
983then
ecda0723 984 usage
5c08dbbd
JH
985fi
986
28f9af5d
PY
987# "--cached" is accepted only by "status" and "summary"
988if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 989then
70c7ac22 990 usage
5c08dbbd
JH
991fi
992
993"cmd_$command" "$@"